<?php

/*
 * $Id: AdminGulliver.php 4221 2014-04-30 07:16:15Z svnpeton $
 * charset: UTF-8
 * 
 * Remarque : pour que le système de traduction fonctionne, il ne faut pas d'espace après le (this->l ('')).
 */
if (!defined ('_PS_VERSION_'))
  exit;

//compatibilité avec presta 1.5.4+
if (!class_exists('AdminTab'))
{
  //compatibilité avec presta 1.5
  if (defined ('PS_ADMIN_DIR'))
    require_once( PS_ADMIN_DIR . '/../classes/AdminTab.php');
  else
    require_once( '../classes/AdminTab.php');
}
class AdminGulliver extends AdminTab
{

  public function __construct ()
  {
    $this->table = 'gulliver';
    $this->className = 'Gulliver';
    $this->lang = false;
    $this->edit = true;
    $this->delete = true;
    
    $this->identifier = 'id_admin_gulliver';

    parent::__construct ();
  }

  public function display ()
  {
    global $currentIndex;
    
    $defaultLanguage = intval (Configuration::get ('PS_LANG_DEFAULT'));
    // $Tlanguages = Language::getLanguages(); // Recherche du $Tlanguages[]['id_lang']=$defaultLanguage

    // Synchronisation du catalogue et des contacts vers Gulliver eMailing
    //echo '<h2>' . $this->l('Extract your catalog for Gulliver Emailing Product') . '</h2>';
    
    //Module Gulliver eMailing
    echo '<h2>' . $this->l('Gulliver eMailing Module') . '</h2>';

    if (isset ($_REQUEST['do']) and $_REQUEST['do'] == "export")
    {
      echo "<br/>";
      echo '<p><b>';
      echo $this->l('The export will start in a few seconds...');
      echo '</b></p>';
      echo '<br/>';

      // ID, REF, MARQUE, CAT, NOM, IMG, ...
    }
    echo '
      <script type="text/javascript">
        id_language = Number(' . $defaultLanguage . ');
      </script>';
    // TODO: Mettre les autres champs en hidden.
    $action_url = htmlentities ($currentIndex . '&do=export&token=' . urlencode ($this->token));
    // ' . ($obj->id ? '<input type="hidden" name="id_' . $this->table . '" value="' . $obj->id . '" />' : '') . '
    
    
    
    // Bloc de liens utiles (différents liens vers le site prestashop.gulliver.com)
    $href_form_access_gulliver_emailing_prestashop = 'http://www.gulliver.com/emailing-prestashop/web/p/FORM_ACCESS/0/0/';
    # $href_bo_emailing = "http://back.tamailcom.com/modif.html";
    $href_bo_emailing = "https://emailing.gulliver.com/";
    $href_support_gulliver_emailing_prestashop = 'http://www.gulliver.com/emailing-prestashop/Contact/p/5/0/0/S=1';
    $href_contact_gulliver_emailing_prestashop = 'http://www.gulliver.com/emailing-prestashop/Contact/p/5/0/0/';
    $href_ressources_gulliver_emailing_prestashop = 'http://www.gulliver.com/emailing-prestashop/emailing-prestashop-Ressources/p/3/1200/0/';
    echo '
      <div class="width3">
        <fieldset>
          <legend><img src="../img/t/AdminGulliver.gif" alt="Gulliver eMailing"/>' . $this->l('Useful Links') . '</legend>
          <p>' . $this->l('To access your customer area on Gulliver eMailing, ') . '<a href="' . htmlentities ($href_form_access_gulliver_emailing_prestashop) . '" title="' . $this->l('Access to your account') . '" target="_blank" style="text-decoration:underline;font-weight:bold;">' . $this->l('click here') . '</a></p>
          <p>' . $this->l('To acces you eMailing account, ') . '<a href="' . htmlentities ($href_bo_emailing) . '" title="' . $this->l('Access to your account') . '" target="_blank" style="text-decoration:underline;font-weight:bold;">' . $this->l('click here') . '</a></p>
          <p>' . $this->l('To contact our technical support, ') . '<a href="' . htmlentities ($href_support_gulliver_emailing_prestashop) . '" title="' . $this->l('Technical Support') . '" target="_blank" style="text-decoration:underline;font-weight:bold;">' . $this->l('click here') . '</a></p>
          <p>' . $this->l('To contact our sales department, ') . '<a href="' . htmlentities ($href_contact_gulliver_emailing_prestashop) . '" title="' . $this->l('Sales Contact') . '" target="_blank" style="text-decoration:underline;font-weight:bold;">' . $this->l('click here') . '</a></p>
          <p>' . $this->l('To view our ressources, ') . '<a href="' . htmlentities ($href_ressources_gulliver_emailing_prestashop) . '" title="' . $this->l('Technical Ressources') . '" target="_blank" style="text-decoration:underline;font-weight:bold;">' . $this->l('click here') . '</a></p>
        </fieldset>
      </div> ';
    
    
    // Synchronisation des contacts vers Gulliver eMailing
    // L'export des contacts est à faire pour mettre à jour les  contacts pour vos emailing
    // Si vous avez choisi l'option "Connexion Catalogue", vous avez la possibilité d'automatiser ce transfert
    echo '
      <div class="clear"><br/></div>
      <form action="' . $action_url . '" method="post" class="width3">
        <input type="hidden" name="do2" value="customer" />
        <fieldset>
          <legend><img src="../img/t/AdminGulliver.gif" alt="Gulliver eMailing"/>' . $this->l('GulliverExport Contact') . '</legend>
            
          <p><b>' . $this->l('Allow to export your contacts database for Gulliver Emailing') . '</b></p>
          
          <div class="clear"><br/></div>
          
          <!-- 
          <label>' . $this->l('Type:') . ' </label>
          <div class="margin-form">' . $this->l('All contacts') . '</div> 
          -->
          
          <label>' . $this->l('Lang:') . '</label>
          <div class="margin-form">
            <select name="select_lang_for_export_contact">
              <option value="ALL" selected="selected">'.$this->l('All').'</option>
              <option value="NO_LANGUAGE">'.$this->l('No Language').'</option>
              <option value="EN">'.$this->l('English').'</option>
              <option value="FR">'.$this->l('French').'</option>
              <option value="DE">'.$this->l('German').'</option>
              <option value="ES">'.$this->l('Spanish').'</option>
              <option value="IT">'.$this->l('Italian').'</option>
            </select>
          </div>
            
        <div class="clear"></div>
        <div class="margin-form">
          <input type="submit" value="' . $this->l('Export contacts') . '" name="SAVE' . $this->table . '" class="button" />
        </div>
        
        <p><i>' . $this->l('To prepare your sending, you can use this export to power your base contacts in Gulliver Emailing.') . '</i></p>
        <p><i>' . $this->l('If you have choose the "Database connexion", you can automated this transfert.') . '</i></p>
            
      </fieldset>
    </form> ';
    
    
    // Exporter les catégories principales vers Gulliver eMailing
    // La synchronisation des catégories est à faire à chaque modification de l'arborescence des catégories principales.
    // Rappel : Les catégories commençant G$ sont utilisées pour indiquer les produits à inclure dans un emailing ( par exemple: G$Newsletter )
    echo '
      <div class="clear"><br/></div>
      <form action="' . $action_url . '" method="post" class="width3">
        <input type="hidden" name="do2" value="category" />
        <fieldset>
          <legend><img src="../img/t/AdminGulliver.gif" alt="Gulliver eMailing"/>' . $this->l('GulliverExport Category') . '</legend>
            
        <p><b>' . $this->l('Export your main categories for Gulliver Emailing Product') . '</b></p>
        
        <div class="clear"><br/></div>
            
          <label>' . $this->l('Lang:') . '</label>
          <div class="margin-form">' . $this->get_select_language () . '</div> 
          
        <div class="clear"></div>
        <div class="margin-form">
          <input type="submit" value="' . $this->l('Export categories') . '" name="SAVE' . $this->table . '" class="button" />
        </div>

        <p><i>' . $this->l('This export must be done for each modification in your tree categories so that Gulliver Emailing Product has the same hierarchy of categories') . '</i></p>
        
        <p><i>' . $this->l('This allows a proper functionning of the import of the catalog in Gulliver Emailing Product.') . '</i></p>

      </fieldset>
    </form> ';
    
    // Synchronisation des produits vers Gulliver eMailing
    // L'export des produits est à faire à chaque que vous préparer un emailing incluant des produits.
    // Si vous avez choisi l'option "Connexion Catalogue", vous avez la possibilité d'automatiser ce transfert
    echo '
      <div class="clear"><br/></div>
      <form action="' . $action_url . '" method="post" class="width3">
        <input type="hidden" name="do2" value="product" />
        <fieldset>
          <legend><img src="../img/t/AdminGulliver.gif" alt="Gulliver eMailing"/>' . $this->l('GulliverExport Product') . '</legend>
            
        <b>' . $this->l('Export your catalog for Gulliver Emailing Product.') . '</b>
        
        <div class="clear"><br/></div>
        
          <label>' . $this->l('Image:') . ' </label>
          <div class="margin-form">' . $this->l('Export links to images') . '</div>

          <label>' . $this->l('Product:') . ' </label>
          <div class="margin-form">' . $this->l('If a product has no reference, a reference will be created which the following pattern: G!nnnnn ') . '</div>

          <label>' . $this->l('Lang:') . ' </label>
          <div class="margin-form">' . $this->get_select_language () . '</div> 
          <!-- 
          <label>' . $this->l('Variations:') . ' </label>
          <div class="margin-form">' . $this->l('Ignored') . '</div>
          -->
         <div class="clear"></div>
         <div class="margin-form">
          <input type="submit" value="' . $this->l('Export catalog') . '" name="SAVE' . $this->table . '" class="button" />
        </div>
        
        <p><i>' . $this->l('The export of articles is to be done at every change of your products to update products in Gulliver Emailing Product.') . '</i></p>' .
            
        '<p><i>' . $this->l('If you have choose the "Database connexion", you can automated this transfert.') . '</i></p>

      </fieldset>
    </form> ';
    
    // Synchronisation des contacts SMS vers Gulliver eMailing
    echo '
      <div class="clear"><br/></div>
      <form action="' . $action_url . '" method="post" class="width3">
        <input type="hidden" name="do2" value="customer_sms" />
        <fieldset>
          <legend><img src="../img/t/AdminGulliver.gif" alt="Gulliver eMailing"/>' . $this->l('GulliverExport SMS') . '</legend>
            
          <p><b>' . $this->l('Allow to export your contacts database for Gulliver Emailing SMS') . '</b></p>
          
          <div class="clear"><br/></div>
    
          <!-- <label>' . $this->l('Lang:') . ' </label>
          <div class="margin-form">' . $this->get_select_language () . '</div> -->
          
          <label>' . $this->l('Type:') . ' </label>
          <div class="margin-form">' . $this->l('All contacts') . '</div> 
          
        <div class="clear"></div>
        <div class="margin-form">
          <input type="submit" value="' . $this->l('Export contacts') . '" name="SAVE' . $this->table . '" class="button" />
        </div>
        
        <!-- <p><i>' . $this->l('To prepare your sending, you can use this export to power your base contacts in Gulliver Emailing.') . '</i></p> -->
        <!-- <p><i>' . $this->l('If you have choose the "Database connexion", you can automated this transfert.') . '</i></p> -->
            
      </fieldset>
    </form> ';
    
    // Export des commandes format XML
    /*echo '
      <div class="clear"><br/></div>
      <form action="' . $action_url . '" method="post" class="width3">
        <input type="hidden" name="do2" value="order" />
        <fieldset>
          <legend><img src="../img/t/AdminGulliver.gif" alt="Gulliver eMailing"/>' . $this->l('GulliverExport Orders') . '</legend>
            
          <p><b>' . $this->l('Allow to export your orders database for Gulliver Segmentation') . '</b></p>
          
          <div class="clear"><br/></div>
          
          <label>' . $this->l('Type:') . ' </label>
          <div class="margin-form">' . $this->l('All orders') . '</div> 
          
        <div class="clear"></div>
        <div class="margin-form">
          <input type="submit" value="' . $this->l('Export orders') . '" name="SAVE' . $this->table . '" class="button" />
        </div>
            
      </fieldset>
    </form> ';*/
    
    
    if (isset ($_REQUEST['do']) and $_REQUEST['do'] == "export")
    {
      $do = 'export';
      if (isset ($_REQUEST['do2']))
        $do2 = $_REQUEST['do2'];
      else
        $do2 = 'product';
     
      if (isset ($_REQUEST['select_id_lang']))
        $id_lang = $_REQUEST['select_id_lang'];
      else
        $id_lang = intval (Configuration::get ('PS_LANG_DEFAULT'));
      
      if (isset ($_REQUEST['select_lang_for_export_contact']))
        $_more_params = '&select_lang_for_export_contact='.$_REQUEST['select_lang_for_export_contact'];
      else
        $_more_params = '';

      $gmdate = gmdate("Y-m-d\TH:i:s\Z");
      $version = '1.0';
      $api_key = Configuration::get ('MOD_GULLIVER_API_KEY');
      $signature = sha1 ("$gmdate$version$do$do2$api_key");

      $url = $currentIndex . '&do=' . urlencode ($do) . '&do=' . urlencode ($do) . '&token=' . urlencode ($this->token) . '&signature=' . urlencode ($signature);
      $url = '../modules/gulliver/export.php?do2=' . urlencode ($do2) .
              '&do=' . urlencode ($do) .
              '&select_id_lang=' . urlencode ($id_lang) .
              '&version=' . urlencode ($version) .
              '&gmdate=' . urlencode ( $gmdate ) .
              '&signature=' . urlencode ($signature) .
              $_more_params;
      echo <<< EOT

      <script type="text/javascript">
      <!-- //       
        function download ()
        {
          document.location='$url';
          // window.open('$url');
        }
        // download ();
        // On laisse une seconde pour finir l'affichage de la page courante.
        setTimeout(function() { download() }, 1000);

      // -->
      </script>
      
EOT;
    }
  }
  
  
  
  //Retourne les infos sur toutes les langues disponibles dans la boutique prestashop
  public function get_all_languages_infos ()
  {
    $Tlang = FALSE;

    $languages = Language::getLanguages(false);

    $Tlang['nb'] = 0;
    foreach($languages as $language)
    {
      if($language['id_lang'] == '' || $language['name'] == '') {continue;}
        
      $id_lang = $language['id_lang'];

      $Tlang['langs'][$id_lang]['id_lang'] = $language['id_lang'];
      $Tlang['langs'][$id_lang]['name'] = $language['name']; 
      $Tlang['langs'][$id_lang]['active'] = $language['active'];
      $Tlang['langs'][$id_lang]['iso_code'] = $language['iso_code']; 
      $Tlang['langs'][$id_lang]['date_format'] = $language['date_format_lite']; 

      $Tlang['nb']++;
    }

    if($Tlang['nb'] == 0){return FALSE;}

    return $Tlang;
  }
  
  
  //retourne le select de choix entre les différentes langues dispo dans la boutique prestashop
  public function get_select_language ()
  {
    $SELECT_LANG = '';
    
    $defaultLanguage = intval (Configuration::get ('PS_LANG_DEFAULT'));
    
    $Tlang = $this->get_all_languages_infos ();

    if($Tlang != FALSE)
    {
      $SELECT_LANG = '<select name="select_id_lang">';
      foreach ($Tlang['langs'] as $lang) 
      {
        if($defaultLanguage == $lang['id_lang'])
          $_selected = ' selected="selected"';
        else
          $_selected = '';
        
        $SELECT_LANG .= '<option value="' . $lang['id_lang'] . '" '.$_selected.'>' . $lang['name'] . '</option>';
      }
      $SELECT_LANG .= '</select>';
    }
    
    return $SELECT_LANG;
  }
}

?>